From 103726a87e43a40c5635bd46e2e5671acc13f1a4 Mon Sep 17 00:00:00 2001
From: Gwenael Casaccio <mrgwen@gmail.com>
Date: Mon, 2 Dec 2013 12:01:58 +0100
Subject: [PATCH] Removes postInitialize calls and makes widget initialization
 consistent

---
 packages/visualgst/ChangeLog                       | 23 ++++++++++++++
 packages/visualgst/Debugger/GtkDebugger.st         | 11 +------
 packages/visualgst/Gtk/GtkScrollTreeWidget.st      |  2 +-
 packages/visualgst/GtkLauncher.st                  | 33 ++++++--------------
 packages/visualgst/GtkWorkspaceWidget.st           |  8 +----
 packages/visualgst/Inspector/GtkInspector.st       | 13 +-------
 .../Inspector/GtkInspectorBrowserWidget.st         |  6 ----
 .../Inspector/GtkInspectorSourceWidget.st          |  1 +
 packages/visualgst/Inspector/GtkInspectorWidget.st | 13 ++------
 packages/visualgst/SUnit/GtkSUnit.st               |  9 +-----
 .../StBrowser/GtkCategorizedNamespaceWidget.st     |  3 +-
 .../visualgst/StBrowser/GtkClassBrowserWidget.st   | 10 ++----
 packages/visualgst/Widget/Compoment.st             |  2 +-
 packages/visualgst/Widget/List.st                  |  6 ++++
 packages/visualgst/Widget/Notebook.st              |  3 +-
 packages/visualgst/Widget/Paned.st                 |  5 +++
 .../visualgst/Widget/Text/GtkSourceCodeWidget.st   | 11 ++-----
 packages/visualgst/Widget/Text/GtkTextWidget.st    | 17 +++++-----
 packages/visualgst/Widget/Tree.st                  |  6 ++++
 packages/visualgst/Widget/Widget.st                |  2 +-
 packages/visualgst/Widget/Window.st                | 36 ++++++++--------------
 21 files changed, 91 insertions(+), 129 deletions(-)

diff --git a/packages/visualgst/ChangeLog b/packages/visualgst/ChangeLog
index 6185ad2..95e381d 100644
--- a/packages/visualgst/ChangeLog
+++ b/packages/visualgst/ChangeLog
@@ -1,5 +1,28 @@
 2013-12-02  Gwenael Casaccio  <gwenael.casaccio@gmail.com>
 
+	* Debugger/GtkDebugger.st: Removes postInitialize calls.
+	* Gtk/GtkScrollTreeWidget.st: Removes postInitialize calls.
+	* GtkLauncher.st: Removes postInitialize calls.
+	* GtkWorkspaceWidget.st: Removes postInitialize calls.
+	* Inspector/GtkInspector.st: Removes postInitialize calls.
+	* Inspector/GtkInspectorBrowserWidget.st: Removes postInitialize calls.
+	* Inspector/GtkInspectorSourceWidget.st: Removes postInitialize calls.
+	* Inspector/GtkInspectorWidget.st: Removes postInitialize calls.
+	* SUnit/GtkSUnit.st: Removes postInitialize calls.
+	* StBrowser/GtkCategorizedNamespaceWidget.st: Removes postInitialize calls.
+	* StBrowser/GtkClassBrowserWidget.st: Removes postInitialize calls.
+	* Widget/Compoment.st: Removes postInitialize calls.
+	* Widget/List.st: Removes postInitialize calls.
+	* Widget/Notebook.st: Removes postInitialize calls.
+	* Widget/Paned.st: Removes postInitialize calls.
+	* Widget/Text/GtkSourceCodeWidget.st: Removes postInitialize calls.
+	* Widget/Text/GtkTextWidget.st: Removes postInitialize calls.
+	* Widget/Tree.st: Removes postInitialize calls.
+	* Widget/Widget.st: Removes postInitialize calls.
+	* Widget/Window.st: Removes postInitialize calls.
+
+2013-12-02  Gwenael Casaccio  <gwenael.casaccio@gmail.com>
+
 	* Debugger/GtkDebugger.st: Migrate to new events.
 	* GtkHistoryWidget.st: Migrate to new events.
 	* GtkLauncher.st: Migrate to new events.
diff --git a/packages/visualgst/Debugger/GtkDebugger.st b/packages/visualgst/Debugger/GtkDebugger.st
index 17789bb..0eb42cf 100644
--- a/packages/visualgst/Debugger/GtkDebugger.st
+++ b/packages/visualgst/Debugger/GtkDebugger.st
@@ -34,6 +34,7 @@
 ======================================================================"
 
 GtkBrowsingTool subclass: GtkDebugger [
+
     | codeWidget contextWidget debugger inspectorWidget stackInspectorWidget |
 
     GtkDebugger class >> open: aString [
@@ -78,16 +79,6 @@ GtkBrowsingTool subclass: GtkDebugger [
 	^ 'About Debugger'
     ]
 
-    postInitialize [
-        <category: 'initialization'>
-
-
-        super postInitialize.
-	codeWidget postInitialize.
-	inspectorWidget postInitialize.
-	stackInspectorWidget postInitialize.
-    ]
- 
     buildContextWidget [
 	<category: 'user interface'>
 
diff --git a/packages/visualgst/Gtk/GtkScrollTreeWidget.st b/packages/visualgst/Gtk/GtkScrollTreeWidget.st
index 2bd9c4a..3ca66dd 100644
--- a/packages/visualgst/Gtk/GtkScrollTreeWidget.st
+++ b/packages/visualgst/Gtk/GtkScrollTreeWidget.st
@@ -60,7 +60,7 @@ GtkConcreteWidget subclass: GtkScrollTreeWidget [
 
 	popupMenu := [ :value | ].
 	self buildTreeView.
-	self mainWidget: (GTK.GtkScrolledWindow withChild: self treeView)
+	self mainWidget: (GTK.GtkScrolledWindow withChild: self treeView).
     ]
 
     buildTreeView [
diff --git a/packages/visualgst/GtkLauncher.st b/packages/visualgst/GtkLauncher.st
index 41ec9f6..0ed618f 100644
--- a/packages/visualgst/GtkLauncher.st
+++ b/packages/visualgst/GtkLauncher.st
@@ -36,7 +36,7 @@
 GtkVisualGSTTool subclass: GtkLauncher [
     GtkLauncher class [ | uniqueInstance | ]
 
-    | leftSidebarP leftSidebar rightSidebar topSidebarP topSidebar packageBuilderWidget implementorResultWidget senderResultWidget senderWidget implementorWidget historyWidget browsers outputs saved imageName transcriptWidget windowsMenu systemChangeNotifier |
+    | bottomSidebarP leftSidebarP leftSidebar rightSidebar topSidebarP topSidebar packageBuilderWidget implementorResultWidget senderResultWidget senderWidget implementorWidget historyWidget browsers outputs saved imageName transcriptWidget windowsMenu systemChangeNotifier |
 
     GtkLauncher class >> uniqueInstance [
 	<category: 'public'>
@@ -64,8 +64,6 @@ GtkVisualGSTTool subclass: GtkLauncher [
 
         ^ (uniqueInstance :=  self basicNew)
             initialize;
-            showAll;
-            postInitialize;
 	    resize: 1024@600;
             yourself
     ]
@@ -132,7 +130,6 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	| widget |
 	browsers addWidget: (widget := self buildClassBrowserWidget) labeled: 'Browser'.
         browsers showLastPage.
-	widget postInitialize.
 	^ widget
     ]
 
@@ -147,7 +144,6 @@ GtkVisualGSTTool subclass: GtkLauncher [
 
 	| widget |
 	widget := self buildWorkspaceWidget.
-	widget postInitialize.
 	outputs addWidget: widget labeled: aString.
         outputs showLastPage.
         ^widget
@@ -304,7 +300,11 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	super initialize.
 	window maximize.
 	window setIcon: (GTK.GdkPixbuf newFromFile: (self class / 'Icons/visualgst.png') file displayString error: nil).
-	self subscribe
+	self subscribe.
+	self hideSidebars.
+        leftSidebarP position: 150.
+        topSidebarP position: 100.
+	window connectSignal: 'key-press-event' to: self selector:  #'keyPressedOn:keyEvent:'
     ]
 
     subscribe [
@@ -326,24 +326,11 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	<category: 'initialization'>
 
         browsers grabFocus.
-        browsers currentWidget postInitialize.
         browsers currentWidget selectANamespace: Smalltalk.
         browsers currentWidget selectAClass: Object.
 	outputs hideAll
     ]
 
-    postInitialize [
-	<category: 'initialization'>
-
-	super postInitialize.
-        self browserPostInitialize.
-	1 to: 2 do: [ :i | (outputs widgetAt: i) postInitialize ].
-	self hideSidebars.
-        leftSidebarP position: 150.
-        topSidebarP position: 100.
-	window connectSignal: 'key-press-event' to: self selector:  #'keyPressedOn:keyEvent:'
-    ]
-
     buildNotebookWorkspaceWidget [
 	<category: 'user interface'>
 
@@ -391,7 +378,7 @@ GtkVisualGSTTool subclass: GtkLauncher [
     buildBrowserAndWorkspaceWidget [
         <category: 'intialize-release'>
 
-        ^ VPaned addAll:
+        ^ bottomSidebarP := VPaned addAll:
 		    { leftSidebarP := HPaned addAll: { self buildImplementorPaned. self buildBottomPanedAndClassBrowser. self buildRightSidebarPaned }. 
 		      self buildNotebookWorkspaceWidget }
     ]
@@ -834,9 +821,9 @@ GtkVisualGSTTool subclass: GtkLauncher [
     showHideBottomPane [
 	<category: 'image events'>
 
-	outputs isVisible 
-		ifTrue: [ outputs hideAll ]
-		ifFalse: [ outputs showPane ]
+	bottomSidebarP position = bottomSidebarP maxPosition
+		ifTrue: [ bottomSidebarP position: bottomSidebarP maxPosition - 200 ]
+		ifFalse: [ bottomSidebarP position: bottomSidebarP maxPosition ]
     ]
 
     back [
diff --git a/packages/visualgst/GtkWorkspaceWidget.st b/packages/visualgst/GtkWorkspaceWidget.st
index 6729eca..066ce4d 100644
--- a/packages/visualgst/GtkWorkspaceWidget.st
+++ b/packages/visualgst/GtkWorkspaceWidget.st
@@ -45,14 +45,8 @@ GtkTextWidget subclass: GtkWorkspaceWidget [
 				yourself.
 	object := variableTracker objectClass new.
 	super initialize.
-	self connectToWhenPopupMenu: (WorkspaceMenus on: self)
-    ]
-
-    postInitialize [
-        <category: 'initialize'>
-
+	self connectToWhenPopupMenu: (WorkspaceMenus on: self).
 	variableWidget hideAll.
-	super postInitialize
     ]
 
     buildWidget [
diff --git a/packages/visualgst/Inspector/GtkInspector.st b/packages/visualgst/Inspector/GtkInspector.st
index 3d864cc..0180819 100644
--- a/packages/visualgst/Inspector/GtkInspector.st
+++ b/packages/visualgst/Inspector/GtkInspector.st
@@ -35,16 +35,14 @@
 ======================================================================"
 
 GtkBrowsingTool subclass: GtkInspector [
+
     | object notebookWidget inspectorWidget browserWidget workspaceWidget |
 
     GtkInspector class >> openOn: anObject [
 	<category: 'user interface'>
 
 	^ (self new)
-	    initialize;
 	    object: anObject;
-	    showAll;
-	    postInitialize;
 	    yourself
     ]
 
@@ -54,15 +52,6 @@ GtkBrowsingTool subclass: GtkInspector [
         ^ '<Inspector>'
     ]
 
-    postInitialize [
-        <category: 'initialization'>
-
-	super postInitialize.
-	browserWidget postInitialize.
-	inspectorWidget postInitialize.
-	workspaceWidget postInitialize.
-    ]
-
     object: anObject [
 	<category: 'accessor'>
 
diff --git a/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st b/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st
index 2cc7335..1af9c3c 100644
--- a/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st
+++ b/packages/visualgst/Inspector/GtkInspectorBrowserWidget.st
@@ -43,12 +43,6 @@ Compoment subclass: GtkInspectorBrowserWidget [
 	^ 'Gtk class browser'
     ]
 
-    postInitialize [
-	<category: 'initialization'>
-
-	codeWidget postInitialize
-    ]
-
     buildBrowser [
 
 	^ HPaned addAll: {self buildHierarchy. self buildProtocolAndMethod}
diff --git a/packages/visualgst/Inspector/GtkInspectorSourceWidget.st b/packages/visualgst/Inspector/GtkInspectorSourceWidget.st
index ed08c77..12e1da6 100644
--- a/packages/visualgst/Inspector/GtkInspectorSourceWidget.st
+++ b/packages/visualgst/Inspector/GtkInspectorSourceWidget.st
@@ -34,6 +34,7 @@
 ======================================================================"
 
 GtkTextWidget subclass: GtkInspectorSourceWidget [
+
     | object |
     
     GtkInspectorSourceWidget class >> openOn: anObject [
diff --git a/packages/visualgst/Inspector/GtkInspectorWidget.st b/packages/visualgst/Inspector/GtkInspectorWidget.st
index 5a255e9..7408fda 100644
--- a/packages/visualgst/Inspector/GtkInspectorWidget.st
+++ b/packages/visualgst/Inspector/GtkInspectorWidget.st
@@ -48,18 +48,12 @@ Compoment subclass: GtkInspectorWidget [
     initialize [
 	<category: 'initialization'>
 
+	self buildView.
         super initialize.
 	stack := OrderedCollection new.
-	self buildView.
 	inspectorTree whenSelectionChangedSend: #onVariableChanged: to: self.
     ]
 
-    postInitialize [
-	<category: 'initialization'>
-
-	workspaceWidget postInitialize
-    ]
-
     inspector: aGtkInspector [
 	<category: 'accessing'>
 
@@ -95,10 +89,7 @@ Compoment subclass: GtkInspectorWidget [
     buildWorkspaceWidget [
 	<category: 'user interface'>
 
-	^ workspaceWidget := (GtkWorkspaceWidget new)
-			    initialize;
-			    showAll;
-			    yourself
+	^ workspaceWidget := GtkWorkspaceWidget new
     ]
 
     buildView [
diff --git a/packages/visualgst/SUnit/GtkSUnit.st b/packages/visualgst/SUnit/GtkSUnit.st
index 938f087..ee2b49d 100644
--- a/packages/visualgst/SUnit/GtkSUnit.st
+++ b/packages/visualgst/SUnit/GtkSUnit.st
@@ -113,14 +113,7 @@ GtkBrowsingTool subclass: GtkSUnit [
         <category: 'initialization'>
 
         super initialize.
-	state := NamespaceState on: self with: Smalltalk
-    ]
-
-    postInitialize [
-        <category: 'initialization'>
-
-	super postInitialize.
-	sourceCodeWidget postInitialize
+	state := NamespaceState on: self with: Smalltalk.
     ]
 
     windowTitle [
diff --git a/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st b/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st
index 799ccda..94d8e08 100644
--- a/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st
+++ b/packages/visualgst/StBrowser/GtkCategorizedNamespaceWidget.st
@@ -39,7 +39,8 @@ Compoment subclass: GtkCategorizedNamespaceWidget [
         <category: 'initialization'>
 
         self buildTreeView.
-	self registerNotifier
+	self registerNotifier.
+        super initialize.
     ]
 
     registerNotifier [
diff --git a/packages/visualgst/StBrowser/GtkClassBrowserWidget.st b/packages/visualgst/StBrowser/GtkClassBrowserWidget.st
index 7bc2366..6396ffa 100644
--- a/packages/visualgst/StBrowser/GtkClassBrowserWidget.st
+++ b/packages/visualgst/StBrowser/GtkClassBrowserWidget.st
@@ -195,12 +195,6 @@ Compoment subclass: GtkClassBrowserWidget [
 	    buildBrowserPaned
     ]
 
-    postInitialize [
-	<category: 'initialize'>
-
-	codeWidget postInitialize
-    ]
-
     updateHistory: aClass [
 	<category: 'history'>
 
@@ -584,7 +578,9 @@ Compoment subclass: GtkClassBrowserWidget [
     sourceCodeWidgetHasFocus [
 	<category: 'testing'>
 
-	^ parentWindow getFocus address = codeWidget textview address
+        " TODO Fix Me "
+	"^ parentWindow getFocus address = codeWidget textview address"
+        ^ false
     ]
 
     copy [
diff --git a/packages/visualgst/Widget/Compoment.st b/packages/visualgst/Widget/Compoment.st
index 48f3b18..e6d6b1b 100644
--- a/packages/visualgst/Widget/Compoment.st
+++ b/packages/visualgst/Widget/Compoment.st
@@ -56,7 +56,7 @@ Widget subclass: Compoment [
     showAll [
 	<category: 'user interface'>
 
-	child showAll
+	child show
     ]
 
     hideAll [
diff --git a/packages/visualgst/Widget/List.st b/packages/visualgst/Widget/List.st
index de761bb..ad2c554 100644
--- a/packages/visualgst/Widget/List.st
+++ b/packages/visualgst/Widget/List.st
@@ -160,6 +160,12 @@ Widget subclass: List [
         announcer on: SelectionChangedAnnouncement do: [ :ann | anObject perform: aSymbol with: ann ]
     ]
 
+    showAll [
+        <category: 'user interface'>
+
+        child showAll
+    ]
+
     onPress: aGtkWidget event: aGdkEvent [
         <category: 'button event'>
 
diff --git a/packages/visualgst/Widget/Notebook.st b/packages/visualgst/Widget/Notebook.st
index fd8c2d4..6cc4bd3 100644
--- a/packages/visualgst/Widget/Notebook.st
+++ b/packages/visualgst/Widget/Notebook.st
@@ -180,8 +180,7 @@ Widget subclass: Notebook [
     showPane [
 	<category: 'widget'>
 
-	child showAll.
-	pages do: [ :each | each postInitialize ]
+	child showAll
     ]
 ]
 
diff --git a/packages/visualgst/Widget/Paned.st b/packages/visualgst/Widget/Paned.st
index 5f41ad0..a93c959 100644
--- a/packages/visualgst/Widget/Paned.st
+++ b/packages/visualgst/Widget/Paned.st
@@ -114,6 +114,11 @@ Widget subclass: Paned [
         ^ child getPosition
     ]
 
+    maxPosition [
+
+        ^ child propertiesAt: 'max-position'
+    ]
+
     paned [
         <category: 'accessing'>
 
diff --git a/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st b/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st
index 7d878c5..79a0248 100644
--- a/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st
+++ b/packages/visualgst/Widget/Text/GtkSourceCodeWidget.st
@@ -34,13 +34,15 @@
 ======================================================================"
 
 GtkTextWidget subclass: GtkSourceCodeWidget [
+
     | browser codeText saveWidget |
 
     initialize [
 	<category: 'initialization'>
 
 	super initialize.
-	self initializeHighlighter
+	self initializeHighlighter.
+        saveWidget hideAll
     ]
 
     initializeHighlighter [
@@ -145,13 +147,6 @@ GtkTextWidget subclass: GtkSourceCodeWidget [
 	saveWidget showAll
     ]
 
-    postInitialize [
-        <category: 'initialize'>
-
-        super postInitialize.
-        saveWidget mainWidget hide
-    ]
-
     acceptIt [
 	<category: 'buffer events'>
 
diff --git a/packages/visualgst/Widget/Text/GtkTextWidget.st b/packages/visualgst/Widget/Text/GtkTextWidget.st
index b08a6ef..2bd3f7e 100644
--- a/packages/visualgst/Widget/Text/GtkTextWidget.st
+++ b/packages/visualgst/Widget/Text/GtkTextWidget.st
@@ -84,14 +84,9 @@ Widget subclass: GtkTextWidget [
 	self 
 	    buildWidget;
 	    connectSignals.
-	
-    ]
-
-    postInitialize [
-        <category: 'initialize'>
-
-        findWidget mainWidget hide.
-        replaceWidget mainWidget hide.
+	super initialize.
+        findWidget hideAll.
+        replaceWidget hideAll.
     ]
 
     buildWidget [
@@ -429,5 +424,11 @@ Widget subclass: GtkTextWidget [
               end := self buffer getIterAtOffset: (iter getOffset).
               self buffer selectRange: start bound: end ]
     ]
+
+    showAll [
+        <category: 'user interface'>
+
+        child showAll
+    ]
 ]
 
diff --git a/packages/visualgst/Widget/Tree.st b/packages/visualgst/Widget/Tree.st
index 6a3115c..8ef3461 100644
--- a/packages/visualgst/Widget/Tree.st
+++ b/packages/visualgst/Widget/Tree.st
@@ -147,6 +147,12 @@ Widget subclass: Tree [
         tree getSelection connectSignal: 'changed' to: anObject selector: aSymbol
     ]
 
+    showAll [
+        <category: 'user interface'>
+
+        child showAll
+    ]
+
     onPress: aGtkWidget event: aGdkEvent [
         <category: 'button event'>
 
diff --git a/packages/visualgst/Widget/Widget.st b/packages/visualgst/Widget/Widget.st
index 11979a3..fb5046c 100644
--- a/packages/visualgst/Widget/Widget.st
+++ b/packages/visualgst/Widget/Widget.st
@@ -102,7 +102,7 @@ Object subclass: Widget [
     showAll [
 	<category: 'user interface'>
 
-	child showAll
+	child show
     ]
 
     hideAll [
diff --git a/packages/visualgst/Widget/Window.st b/packages/visualgst/Widget/Window.st
index e3f8a4c..c072828 100644
--- a/packages/visualgst/Widget/Window.st
+++ b/packages/visualgst/Widget/Window.st
@@ -40,21 +40,14 @@ Widget subclass: Window [
     Window class >> open [
 	<category: 'user interface'>
 
-	^ (self new)
-	    initialize;
-	    showAll;
-	    postInitialize;
-	    yourself
+	^ self new
     ]
 
     Window class >> openSized: aPoint [
 	<category: 'user interface'>
 	
-	^ (self new)
-	    initialize;
+	^ self new
 	    resize: aPoint;
-	    showAll;
-	    postInitialize;
 	    yourself
     ]
 
@@ -87,7 +80,7 @@ Widget subclass: Window [
     menuBar [
 	<category: 'accessing'>
 
-	^ menuBar ifNil: [ menuBar := GTK.GtkMenuBar new ]
+	^ menuBar ifNil: [ (menuBar := GTK.GtkMenuBar new) showAll ]
     ]
 
     menuBar: aGtkMenuBar [
@@ -168,12 +161,15 @@ that are specific to this version of GNU Smalltalk.';
 	
 	window := GTK.GtkWindow	new: GTK.Gtk gtkWindowToplevel.
 	window addAccelGroup: self accelGroup.
+        window connectSignal: 'delete-event' to: self selector: #'onDelete:event:'.
+        window showAll.
         self
             title: self windowTitle;
             createMenus;
             createToolbar;
             createStatusBar;
-            centralWidget: self buildCentralWidget
+            centralWidget: self buildCentralWidget;
+            showAll
     ]
 
     buildCentralWidget [
@@ -200,13 +196,6 @@ that are specific to this version of GNU Smalltalk.';
 	<category: 'initialization'>
     ]
 
-    postInitialize [
-	<category: 'initialization'>
-
-        window
-            connectSignal: 'delete-event' to: self selector: #'onDelete:event:'
-    ]
-
     onDelete: aGtkWidget event: aGdkEvent [
 	<category: 'events'>
 
@@ -279,13 +268,14 @@ that are specific to this version of GNU Smalltalk.';
     ]
 
     showAll [
+        self container showAll.
+
 	{menuBar->false. toolBar->false. centralWidget->true. statusBar->false} do: [ :each |
-	    each key ifNotNil: [ self container 
-		packStart: each key expand: each value fill: true padding: 0 ] ].
+	    each key ifNotNil: [ 
+                each value ifFalse: [ each key showAll ].
+                self container packStart: each key expand: each value fill: true padding: 0 ] ].
 
-	window 
-	    add: self container;
-	    showAll
+	window add: self container
     ]
 
     focusedWidget [
-- 
1.8.3.2